diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/stats/model/gnuplot.cc ns-3.38/src/stats/model/gnuplot.cc
--- ns-3.37/src/stats/model/gnuplot.cc	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/stats/model/gnuplot.cc	2023-03-16 20:54:23.828869000 -0700
@@ -173,8 +173,8 @@
 {
     // *** Data Variables ***
 
-    enum Style m_style;         //!< The plotting style to use for this dataset.
-    enum ErrorBars m_errorBars; //!< Whether errorbars should be used for this dataset.
+    Style m_style;         //!< The plotting style to use for this dataset.
+    ErrorBars m_errorBars; //!< Whether errorbars should be used for this dataset.
 
     PointSet m_pointset; //!< The set of points in this data set
 
@@ -223,7 +223,7 @@
         os << "\"" << dataFileName << "\" index " << dataFileDatasetIndex;
     }
 
-    if (m_title.size())
+    if (!m_title.empty())
     {
         os << " title \"" << m_title << "\"";
     }
@@ -284,7 +284,7 @@
         break;
     }
 
-    if (m_extra.size())
+    if (!m_extra.empty())
     {
         os << " " << m_extra;
     }
@@ -334,7 +334,7 @@
 bool
 Gnuplot2dDataset::Data2d::IsEmpty() const
 {
-    return (m_pointset.size() == 0);
+    return m_pointset.empty();
 }
 
 // --- Gnuplot2dDataset ---------------------------------------------------- //
@@ -350,25 +350,25 @@
 }
 
 void
-Gnuplot2dDataset::SetDefaultStyle(enum Style style)
+Gnuplot2dDataset::SetDefaultStyle(Style style)
 {
     m_defaultStyle = style;
 }
 
 void
-Gnuplot2dDataset::SetStyle(enum Style style)
+Gnuplot2dDataset::SetStyle(Style style)
 {
     reinterpret_cast<Data2d*>(m_data)->m_style = style;
 }
 
 void
-Gnuplot2dDataset::SetDefaultErrorBars(enum ErrorBars errorBars)
+Gnuplot2dDataset::SetDefaultErrorBars(ErrorBars errorBars)
 {
     m_defaultErrorBars = errorBars;
 }
 
 void
-Gnuplot2dDataset::SetErrorBars(enum ErrorBars errorBars)
+Gnuplot2dDataset::SetErrorBars(ErrorBars errorBars)
 {
     reinterpret_cast<Data2d*>(m_data)->m_errorBars = errorBars;
 }
@@ -378,7 +378,7 @@
 {
     NS_ASSERT(reinterpret_cast<Data2d*>(m_data)->m_errorBars == NONE);
 
-    struct Point data;
+    Point data;
     data.empty = false;
     data.x = x;
     data.y = y;
@@ -393,7 +393,7 @@
     NS_ASSERT(reinterpret_cast<Data2d*>(m_data)->m_errorBars == X ||
               reinterpret_cast<Data2d*>(m_data)->m_errorBars == Y);
 
-    struct Point data;
+    Point data;
     data.empty = false;
     data.x = x;
     data.y = y;
@@ -407,7 +407,7 @@
 {
     NS_ASSERT(reinterpret_cast<Data2d*>(m_data)->m_errorBars == XY);
 
-    struct Point data;
+    Point data;
     data.empty = false;
     data.x = x;
     data.y = y;
@@ -419,7 +419,7 @@
 void
 Gnuplot2dDataset::AddEmptyLine()
 {
-    struct Point data;
+    Point data;
     data.empty = true;
     reinterpret_cast<Data2d*>(m_data)->m_pointset.push_back(data);
 }
@@ -474,12 +474,12 @@
 {
     os << m_function;
 
-    if (m_title.size())
+    if (!m_title.empty())
     {
         os << " title \"" << m_title << "\"";
     }
 
-    if (m_extra.size())
+    if (!m_extra.empty())
     {
         os << " " << m_extra;
     }
@@ -559,17 +559,17 @@
 {
     os << "\"-\" ";
 
-    if (m_style.size())
+    if (!m_style.empty())
     {
         os << " " << m_style;
     }
 
-    if (m_title.size())
+    if (!m_title.empty())
     {
         os << " title \"" << m_title << "\"";
     }
 
-    if (m_extra.size())
+    if (!m_extra.empty())
     {
         os << " " << m_extra;
     }
@@ -594,7 +594,7 @@
 bool
 Gnuplot3dDataset::Data3d::IsEmpty() const
 {
-    return (m_pointset.size() == 0);
+    return m_pointset.empty();
 }
 
 // --- Gnuplot3dDataset ---------------------------------------------------- //
@@ -621,7 +621,7 @@
 void
 Gnuplot3dDataset::Add(double x, double y, double z)
 {
-    struct Point data;
+    Point data;
     data.empty = false;
     data.x = x;
     data.y = y;
@@ -632,7 +632,7 @@
 void
 Gnuplot3dDataset::AddEmptyLine()
 {
-    struct Point data;
+    Point data;
     data.empty = true;
     reinterpret_cast<Data3d*>(m_data)->m_pointset.push_back(data);
 }
@@ -687,12 +687,12 @@
 {
     os << m_function;
 
-    if (m_title.size())
+    if (!m_title.empty())
     {
         os << " title \"" << m_title << "\"";
     }
 
-    if (m_extra.size())
+    if (!m_extra.empty())
     {
         os << " " << m_extra;
     }
@@ -812,32 +812,32 @@
 void
 Gnuplot::GenerateOutput(std::ostream& osControl, std::ostream& osData, std::string dataFileName)
 {
-    if (m_terminal.size())
+    if (!m_terminal.empty())
     {
         osControl << "set terminal " << m_terminal << std::endl;
     }
 
-    if (m_outputFilename.size())
+    if (!m_outputFilename.empty())
     {
         osControl << "set output \"" << m_outputFilename << "\"" << std::endl;
     }
 
-    if (m_title.size())
+    if (!m_title.empty())
     {
         osControl << "set title \"" << m_title << "\"" << std::endl;
     }
 
-    if (m_xLegend.size())
+    if (!m_xLegend.empty())
     {
         osControl << "set xlabel \"" << m_xLegend << "\"" << std::endl;
     }
 
-    if (m_yLegend.size())
+    if (!m_yLegend.empty())
     {
         osControl << "set ylabel \"" << m_yLegend << "\"" << std::endl;
     }
 
-    if (m_extra.size())
+    if (!m_extra.empty())
     {
         osControl << m_extra << std::endl;
     }
@@ -940,12 +940,12 @@
     // If this version of this function is called, it is assumed that a
     // single output file is being generated.
 
-    if (m_terminal.size())
+    if (!m_terminal.empty())
     {
         os << "set terminal " << m_terminal << std::endl;
     }
 
-    if (m_outputFilename.size())
+    if (!m_outputFilename.empty())
     {
         os << "set output \"" << m_outputFilename << "\"" << std::endl;
     }
@@ -964,12 +964,12 @@
     // If this version of this function is called, it is assumed that
     // separate output and date files are being generated.
 
-    if (m_terminal.size())
+    if (!m_terminal.empty())
     {
         osControl << "set terminal " << m_terminal << std::endl;
     }
 
-    if (m_outputFilename.size())
+    if (!m_outputFilename.empty())
     {
         osControl << "set output \"" << m_outputFilename << "\"" << std::endl;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/stats/model/gnuplot.h ns-3.38/src/stats/model/gnuplot.h
--- ns-3.37/src/stats/model/gnuplot.h	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/stats/model/gnuplot.h	2023-03-16 20:54:23.828869000 -0700
@@ -153,18 +153,18 @@
      * Change default style for all newly created objects.
      * \param style the style of plotting to use for newly created datasets.
      */
-    static void SetDefaultStyle(enum Style style);
+    static void SetDefaultStyle(Style style);
 
     /**
      * \param style the style of plotting to use for this dataset.
      */
-    void SetStyle(enum Style style);
+    void SetStyle(Style style);
 
     /**
      * Change default errorbars style for all newly created objects.
      * \param errorBars the style of errorbars to use for newly created datasets.
      */
-    static void SetDefaultErrorBars(enum ErrorBars errorBars);
+    static void SetDefaultErrorBars(ErrorBars errorBars);
 
     /**
      * \param errorBars the style of errorbars to display.
@@ -174,7 +174,7 @@
      * this dataset with the right GnuplotDataset::Add
      * method.
      */
-    void SetErrorBars(enum ErrorBars errorBars);
+    void SetErrorBars(ErrorBars errorBars);
 
     /**
      * \param x x coord to new data point
@@ -225,8 +225,8 @@
     /// The set of points in the dataset
     typedef std::vector<struct Point> PointSet;
 
-    static enum Style m_defaultStyle;         //!< default plot style
-    static enum ErrorBars m_defaultErrorBars; //!< default error bars type
+    static Style m_defaultStyle;         //!< default plot style
+    static ErrorBars m_defaultErrorBars; //!< default error bars type
 
     /// Forward declaration of the internal data class.
     struct Data2d;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/stats/model/histogram.cc ns-3.38/src/stats/model/histogram.cc
--- ns-3.37/src/stats/model/histogram.cc	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/stats/model/histogram.cc	2023-03-16 20:54:23.828869000 -0700
@@ -46,13 +46,13 @@
 }
 
 double
-Histogram::GetBinStart(uint32_t index)
+Histogram::GetBinStart(uint32_t index) const
 {
     return index * m_binWidth;
 }
 
 double
-Histogram::GetBinEnd(uint32_t index)
+Histogram::GetBinEnd(uint32_t index) const
 {
     return (index + 1) * m_binWidth;
 }
@@ -66,7 +66,7 @@
 void
 Histogram::SetDefaultBinWidth(double binWidth)
 {
-    NS_ASSERT(m_histogram.size() == 0); // we can only change the bin width if no values were added
+    NS_ASSERT(m_histogram.empty()); // we can only change the bin width if no values were added
     m_binWidth = binWidth;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/stats/model/histogram.h ns-3.38/src/stats/model/histogram.h
--- ns-3.37/src/stats/model/histogram.h	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/stats/model/histogram.h	2023-03-16 20:54:23.828869000 -0700
@@ -64,13 +64,13 @@
      * \param index the bin index
      * \return the bin start
      */
-    double GetBinStart(uint32_t index);
+    double GetBinStart(uint32_t index) const;
     /**
      * \brief Returns the bin end, i.e., (index+1)*binWidth
      * \param index the bin index
      * \return the bin start
      */
-    double GetBinEnd(uint32_t index);
+    double GetBinEnd(uint32_t index) const;
     /**
      * \brief Returns the bin width.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/stats/model/omnet-data-output.cc ns-3.38/src/stats/model/omnet-data-output.cc
--- ns-3.37/src/stats/model/omnet-data-output.cc	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/stats/model/omnet-data-output.cc	2023-03-16 20:54:23.828869000 -0700
@@ -167,11 +167,11 @@
 {
     NS_LOG_FUNCTION(this << context << name << statSum);
 
-    if (context == "")
+    if (context.empty())
     {
         context = ".";
     }
-    if (name == "")
+    if (name.empty())
     {
         name = "\"\"";
     }
@@ -213,11 +213,11 @@
 {
     NS_LOG_FUNCTION(this << context << name << val);
 
-    if (context == "")
+    if (context.empty())
     {
         context = ".";
     }
-    if (name == "")
+    if (name.empty())
     {
         name = "\"\"";
     }
@@ -232,11 +232,11 @@
 {
     NS_LOG_FUNCTION(this << context << name << val);
 
-    if (context == "")
+    if (context.empty())
     {
         context = ".";
     }
-    if (name == "")
+    if (name.empty())
     {
         name = "\"\"";
     }
@@ -251,11 +251,11 @@
 {
     NS_LOG_FUNCTION(this << context << name << val);
 
-    if (context == "")
+    if (context.empty())
     {
         context = ".";
     }
-    if (name == "")
+    if (name.empty())
     {
         name = "\"\"";
     }
@@ -270,11 +270,11 @@
 {
     NS_LOG_FUNCTION(this << context << name << val);
 
-    if (context == "")
+    if (context.empty())
     {
         context = ".";
     }
-    if (name == "")
+    if (name.empty())
     {
         name = "\"\"";
     }
@@ -289,11 +289,11 @@
 {
     NS_LOG_FUNCTION(this << context << name << val);
 
-    if (context == "")
+    if (context.empty())
     {
         context = ".";
     }
-    if (name == "")
+    if (name.empty())
     {
         name = "\"\"";
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/stats/test/double-probe-test-suite.cc ns-3.38/src/stats/test/double-probe-test-suite.cc
--- ns-3.37/src/stats/test/double-probe-test-suite.cc	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/stats/test/double-probe-test-suite.cc	2023-03-16 20:54:23.832869300 -0700
@@ -51,13 +51,13 @@
     }
 
     /// \return the time delta of the next report.
-    double GetTime()
+    double GetTime() const
     {
         return m_time;
     }
 
     /// \return a random variable, different for each reschedule.
-    double GetValue()
+    double GetValue() const
     {
         return aux;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/tap-bridge/examples/lxc-left.conf ns-3.38/src/tap-bridge/examples/lxc-left.conf
--- ns-3.37/src/tap-bridge/examples/lxc-left.conf	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/tap-bridge/examples/lxc-left.conf	2023-03-16 20:54:23.832869300 -0700
@@ -1,7 +1,7 @@
 # Container with network virtualized using a pre-configured bridge named br-left and
 # veth pair virtual network devices
-lxc.utsname = left
-lxc.network.type = veth
-lxc.network.flags = up
-lxc.network.link = br-left
-lxc.network.ipv4 = 10.0.0.1/24
+lxc.uts.name = left
+lxc.net.0.type = veth
+lxc.net.0.flags = up
+lxc.net.0.link = br-left
+lxc.net.0.ipv4.address = 10.0.0.1/24
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/tap-bridge/examples/lxc-right.conf ns-3.38/src/tap-bridge/examples/lxc-right.conf
--- ns-3.37/src/tap-bridge/examples/lxc-right.conf	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/tap-bridge/examples/lxc-right.conf	2023-03-16 20:54:23.832869300 -0700
@@ -1,7 +1,7 @@
 # Container with network virtualized using a pre-configured bridge named br-right and
 # veth pair virtual network devices
-lxc.utsname = right
-lxc.network.type = veth
-lxc.network.flags = up
-lxc.network.link = br-right
-lxc.network.ipv4 = 10.0.0.2/24
+lxc.uts.name = right
+lxc.net.0.type = veth
+lxc.net.0.flags = up
+lxc.net.0.link = br-right
+lxc.net.0.ipv4.address = 10.0.0.2/24
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/tap-bridge/examples/tap-csma.cc ns-3.38/src/tap-bridge/examples/tap-csma.cc
--- ns-3.37/src/tap-bridge/examples/tap-csma.cc	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/tap-bridge/examples/tap-csma.cc	2023-03-16 20:54:23.832869300 -0700
@@ -109,4 +109,6 @@
     Simulator::Stop(Seconds(60.));
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/tap-bridge/examples/tap-csma-virtual-machine.cc ns-3.38/src/tap-bridge/examples/tap-csma-virtual-machine.cc
--- ns-3.37/src/tap-bridge/examples/tap-csma-virtual-machine.cc	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/tap-bridge/examples/tap-csma-virtual-machine.cc	2023-03-16 20:54:23.832869300 -0700
@@ -21,7 +21,7 @@
 // The actual steps required to configure the virtual machines can be rather
 // involved, so we don't go into that here.  Please have a look at one of
 // our HOWTOs on the nsnam wiki for more details about how to get the
-// system confgured.  For an example, have a look at "HOWTO Use Linux
+// system configured.  For an example, have a look at "HOWTO Use Linux
 // Containers to set up virtual networks" which uses this code as an
 // example.
 //
@@ -126,4 +126,6 @@
     Simulator::Stop(Seconds(600.));
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/tap-bridge/examples/tap-wifi-dumbbell.cc ns-3.38/src/tap-bridge/examples/tap-wifi-dumbbell.cc
--- ns-3.37/src/tap-bridge/examples/tap-wifi-dumbbell.cc	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/tap-bridge/examples/tap-wifi-dumbbell.cc	2023-03-16 20:54:23.832869300 -0700
@@ -228,4 +228,6 @@
     Simulator::Stop(Seconds(60.));
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/tap-bridge/examples/tap-wifi-virtual-machine.cc ns-3.38/src/tap-bridge/examples/tap-wifi-virtual-machine.cc
--- ns-3.37/src/tap-bridge/examples/tap-wifi-virtual-machine.cc	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/tap-bridge/examples/tap-wifi-virtual-machine.cc	2023-03-16 20:54:23.832869300 -0700
@@ -21,7 +21,7 @@
 // The actual steps required to configure the virtual machines can be rather
 // involved, so we don't go into that here.  Please have a look at one of
 // our HOWTOs on the nsnam wiki for more details about how to get the
-// system confgured.  For an example, have a look at "HOWTO Use Linux
+// system configured.  For an example, have a look at "HOWTO Use Linux
 // Containers to set up virtual networks" which uses this code as an
 // example.
 //
@@ -165,4 +165,6 @@
     Simulator::Stop(Seconds(600.));
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/tap-bridge/examples/virtual-network-setup.sh ns-3.38/src/tap-bridge/examples/virtual-network-setup.sh
--- ns-3.37/src/tap-bridge/examples/virtual-network-setup.sh	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/tap-bridge/examples/virtual-network-setup.sh	2023-03-16 20:54:23.832869300 -0700
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
 brctl addbr br-left
 brctl addbr br-right
 tunctl -t tap-left
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/tap-bridge/examples/virtual-network-teardown.sh ns-3.38/src/tap-bridge/examples/virtual-network-teardown.sh
--- ns-3.37/src/tap-bridge/examples/virtual-network-teardown.sh	2022-11-01 17:37:24.715395700 -0700
+++ ns-3.38/src/tap-bridge/examples/virtual-network-teardown.sh	2023-03-16 20:54:23.832869300 -0700
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
 lxc-stop -n left
 lxc-stop -n right
 lxc-destroy -n left
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/tap-bridge/model/tap-bridge.cc ns-3.38/src/tap-bridge/model/tap-bridge.cc
--- ns-3.37/src/tap-bridge/model/tap-bridge.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/tap-bridge/model/tap-bridge.cc	2023-03-16 20:54:23.832869300 -0700
@@ -292,7 +292,7 @@
     // In ConfigureLocal mode, the user is asking the TapBridge to do the
     // configuration and create a TAP with the provided "DeviceName" with which
     // the user can later do what she wants.  We need to extract values for the
-    // MAC address, IP address, net mask, etc, from the simualtion itself and
+    // MAC address, IP address, net mask, etc, from the simulation itself and
     // use them to initialize corresponding values on the created tap device.
     //
     // In UseBridge mode, the user is asking us to use an existing tap device
@@ -1092,7 +1092,7 @@
 }
 
 void
-TapBridge::SetMode(enum Mode mode)
+TapBridge::SetMode(Mode mode)
 {
     NS_LOG_FUNCTION(this << mode);
     m_mode = mode;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/tap-bridge/model/tap-creator.cc ns-3.38/src/tap-bridge/model/tap-creator.cc
--- ns-3.37/src/tap-bridge/model/tap-creator.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/tap-bridge/model/tap-creator.cc	2023-03-16 20:54:23.832869300 -0700
@@ -38,7 +38,7 @@
 
 #define TAP_MAGIC 95549
 
-static int gVerbose = 0; // Set to true to turn on logging messages.
+static bool gVerbose = false; // Set to true to turn on logging messages.
 
 #define LOG(msg)                                                                                   \
     if (gVerbose)                                                                                  \
@@ -474,7 +474,7 @@
     // in order to keep the main simulation program from having to be run with
     // root privileges.  We need root privileges to be able to futz with the
     // Tap device underlying all of this.  So all of these hoops are to allow
-    // us to exeucte the following code:
+    // us to execute the following code:
     //
     LOG("Creating Tap");
     int sock = CreateTap(dev, gw, ip, mac, operatingMode, netmask);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/test/csma-system-test-suite.cc ns-3.38/src/test/csma-system-test-suite.cc
--- ns-3.37/src/test/csma-system-test-suite.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/test/csma-system-test-suite.cc	2023-03-16 20:54:23.832869300 -0700
@@ -38,13 +38,13 @@
 #include "ns3/packet-socket-address.h"
 #include "ns3/packet-socket-helper.h"
 #include "ns3/packet.h"
+#include "ns3/ping-helper.h"
 #include "ns3/pointer.h"
 #include "ns3/simple-channel.h"
 #include "ns3/simulator.h"
 #include "ns3/string.h"
 #include "ns3/test.h"
 #include "ns3/uinteger.h"
-#include "ns3/v4ping-helper.h"
 
 #include <string>
 
@@ -784,23 +784,18 @@
     void DoRun() override;
     /**
      * Sink called when a packet is received by a node.
-     * \param p Received packet (unused).
-     * \param ad Sender's address (uused).
      */
-    void SinkRx(Ptr<const Packet> p, const Address& ad);
+    void SinkRx(Ptr<const Packet>, const Address&);
 
     /**
-     * Sink called when a PING ois received.
-     * \param context Context path (unused).
-     * \param rtt Round Trip Time (unused).
+     * Sink called when a PING is received.
      */
-    void PingRtt(std::string context, Time rtt);
+    void PingRtt(std::string, uint16_t, Time);
 
     /**
      * Sink called when a packet is dropped.
-     * \param p Received packet (unused).
      */
-    void DropEvent(Ptr<const Packet> p);
+    void DropEvent(Ptr<const Packet>);
 
     uint32_t m_countSinkRx;  //!< Counter of received packets.
     uint32_t m_countPingRtt; //!< Counter of PING received.
@@ -821,19 +816,19 @@
 }
 
 void
-CsmaPingTestCase::SinkRx(Ptr<const Packet> p, const Address& ad)
+CsmaPingTestCase::SinkRx(Ptr<const Packet>, const Address&)
 {
     m_countSinkRx++;
 }
 
 void
-CsmaPingTestCase::PingRtt(std::string context, Time rtt)
+CsmaPingTestCase::PingRtt(std::string, uint16_t, Time)
 {
     m_countPingRtt++;
 }
 
 void
-CsmaPingTestCase::DropEvent(Ptr<const Packet> p)
+CsmaPingTestCase::DropEvent(Ptr<const Packet>)
 {
     m_drops++;
 }
@@ -888,7 +883,7 @@
     apps.Start(Seconds(0.0));
     apps.Stop(Seconds(11.0));
 
-    V4PingHelper ping = V4PingHelper(addresses.GetAddress(2));
+    PingHelper ping(addresses.GetAddress(2));
     NodeContainer pingers;
     pingers.Add(c.Get(0));
     pingers.Add(c.Get(1));
@@ -902,7 +897,7 @@
                                   MakeCallback(&CsmaPingTestCase::SinkRx, this));
 
     // Trace pings
-    Config::Connect("/NodeList/*/ApplicationList/*/$ns3::V4Ping/Rtt",
+    Config::Connect("/NodeList/*/ApplicationList/*/$ns3::Ping/Rtt",
                     MakeCallback(&CsmaPingTestCase::PingRtt, this));
 
     Simulator::Run();
@@ -1151,7 +1146,7 @@
     // assign addresses to them as well.  We put all of the fill devices into
     // a single device container, so the first nFill devices are associated
     // with the channel connected to spokeDevices.Get (0), the second nFill
-    // devices afe associated with the channel connected to spokeDevices.Get (1)
+    // devices are associated with the channel connected to spokeDevices.Get (1)
     // etc.
     //
     Ipv4AddressHelper address;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/test/doc/tests.h ns-3.38/src/test/doc/tests.h
--- ns-3.37/src/test/doc/tests.h	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/test/doc/tests.h	2023-03-16 20:54:23.832869300 -0700
@@ -61,7 +61,7 @@
  * \brief Performance System Tests
  *
  * Note: these tests are (for real) scripts to be run.
- * The ouput is the time (in nanoseconds) that the test
+ * The output is the time (in nanoseconds) that the test
  * required to perform the requested write operations.
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/test/ns3tc/fq-cobalt-queue-disc-test-suite.cc ns-3.38/src/test/ns3tc/fq-cobalt-queue-disc-test-suite.cc
--- ns-3.37/src/test/ns3tc/fq-cobalt-queue-disc-test-suite.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/test/ns3tc/fq-cobalt-queue-disc-test-suite.cc	2023-03-16 20:54:23.832869300 -0700
@@ -1626,7 +1626,7 @@
                           "Cobalt keeps drop_next as now and the next packet is marked. With "
                           "second dequeue count increases to 2, drop_next becomes now plus around"
                           "70ms which is less than the running time(140), and as the queue delay "
-                          "is persistantly higher than 5ms, second packet is marked.");
+                          "is persistently higher than 5ms, second packet is marked.");
     NS_TEST_EXPECT_MSG_EQ(q1->GetStats().GetNDroppedPackets(CobaltQueueDisc::TARGET_EXCEEDED_DROP),
                           0,
                           "There should not be any dropped packets");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/test/ns3tcp/ns3tcp-loss-test-suite.cc ns-3.38/src/test/ns3tcp/ns3tcp-loss-test-suite.cc
--- ns-3.37/src/test/ns3tcp/ns3tcp-loss-test-suite.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/test/ns3tcp/ns3tcp-loss-test-suite.cc	2023-03-16 20:54:23.832869300 -0700
@@ -35,7 +35,7 @@
 #include "ns3/string.h"
 #include "ns3/tcp-header.h"
 #include "ns3/tcp-socket-factory.h"
-#include "ns3/tcp-westwood.h"
+#include "ns3/tcp-westwood-plus.h"
 #include "ns3/test.h"
 #include "ns3/uinteger.h"
 
@@ -101,7 +101,7 @@
     std::string m_tcpModel;         //!< The TCP model name.
 
     /**
-     * Check that the transmitted packets are consitent with the trace.
+     * Check that the transmitted packets are consistent with the trace.
      * This callback is hooked to ns3::Ipv4L3Protocol/Tx.
      *
      * \param context The callback context (unused).
@@ -146,7 +146,7 @@
       m_writeResults(WRITE_PCAP),
       m_writeLogging(WRITE_LOGGING),
       m_needToClose(true),
-      m_tcpModel("ns3::TcpWestwood")
+      m_tcpModel("ns3::TcpWestwoodPlus")
 {
 }
 
@@ -351,15 +351,7 @@
 
     std::ostringstream tcpModel;
     tcpModel << "ns3::Tcp" << m_tcpModel;
-    if (m_tcpModel == "WestwoodPlus")
-    {
-        Config::SetDefault("ns3::TcpL4Protocol::SocketType", TypeIdValue(TcpWestwood::GetTypeId()));
-        Config::SetDefault("ns3::TcpWestwood::ProtocolType", EnumValue(TcpWestwood::WESTWOODPLUS));
-    }
-    else
-    {
-        Config::SetDefault("ns3::TcpL4Protocol::SocketType", StringValue(tcpModel.str()));
-    }
+    Config::SetDefault("ns3::TcpL4Protocol::SocketType", StringValue(tcpModel.str()));
 
     Config::SetDefault("ns3::TcpSocket::SegmentSize", UintegerValue(1000));
     Config::SetDefault("ns3::TcpSocket::DelAckCount", UintegerValue(1));
@@ -370,7 +362,7 @@
         LogComponentEnableAll(LOG_PREFIX_FUNC);
         LogComponentEnable("Ns3TcpLossTest", LOG_LEVEL_ALL);
         LogComponentEnable("ErrorModel", LOG_LEVEL_DEBUG);
-        LogComponentEnable("TcpWestwood", LOG_LEVEL_ALL);
+        LogComponentEnable("TcpWestwoodPlus", LOG_LEVEL_ALL);
         LogComponentEnable("TcpCongestionOps", LOG_LEVEL_INFO);
         LogComponentEnable("TcpSocketBase", LOG_LEVEL_INFO);
     }
@@ -530,12 +522,6 @@
     AddTestCase(new Ns3TcpLossTestCase("NewReno", 3), TestCase::QUICK);
     AddTestCase(new Ns3TcpLossTestCase("NewReno", 4), TestCase::QUICK);
 
-    AddTestCase(new Ns3TcpLossTestCase("Westwood", 0), TestCase::QUICK);
-    AddTestCase(new Ns3TcpLossTestCase("Westwood", 1), TestCase::QUICK);
-    AddTestCase(new Ns3TcpLossTestCase("Westwood", 2), TestCase::QUICK);
-    AddTestCase(new Ns3TcpLossTestCase("Westwood", 3), TestCase::QUICK);
-    AddTestCase(new Ns3TcpLossTestCase("Westwood", 4), TestCase::QUICK);
-
     AddTestCase(new Ns3TcpLossTestCase("WestwoodPlus", 0), TestCase::QUICK);
     AddTestCase(new Ns3TcpLossTestCase("WestwoodPlus", 1), TestCase::QUICK);
     AddTestCase(new Ns3TcpLossTestCase("WestwoodPlus", 2), TestCase::QUICK);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/test/ns3tcp/ns3tcp-socket-writer.h ns-3.38/src/test/ns3tcp/ns3tcp-socket-writer.h
--- ns-3.37/src/test/ns3tcp/ns3tcp-socket-writer.h	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/test/ns3tcp/ns3tcp-socket-writer.h	2023-03-16 20:54:23.832869300 -0700
@@ -43,7 +43,7 @@
     /**
      * Setup the socket.
      * \param node The node owning the socket.
-     * \param peer The destinaiton address.
+     * \param peer The destination address.
      */
     void Setup(Ptr<Node> node, Address peer);
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/test/ns3tcp/ns3tcp-state-test-suite.cc ns-3.38/src/test/ns3tcp/ns3tcp-state-test-suite.cc
--- ns-3.37/src/test/ns3tcp/ns3tcp-state-test-suite.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/test/ns3tcp/ns3tcp-state-test-suite.cc	2023-03-16 20:54:23.832869300 -0700
@@ -98,7 +98,7 @@
     bool m_needToClose;         //!< Check if the sending socket need to be closed.
 
     /**
-     * Check that the transmitted packets are consitent with the trace.
+     * Check that the transmitted packets are consistent with the trace.
      * This callback is hooked to ns3::Ipv4L3Protocol/Tx.
      *
      * \param context The callback context (unused).
@@ -111,7 +111,7 @@
                   Ptr<Ipv4> ipv4,
                   uint32_t interface);
     /**
-     * Check that the received packets are consitent with the trace.
+     * Check that the received packets are consistent with the trace.
      * This callback is hooked to ns3::Ipv4L3Protocol/Tx.
      *
      * \param context The callback context (unused).
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/test/ns3wifi/wifi-ac-mapping-test-suite.cc ns-3.38/src/test/ns3wifi/wifi-ac-mapping-test-suite.cc
--- ns-3.37/src/test/ns3wifi/wifi-ac-mapping-test-suite.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/test/ns3wifi/wifi-ac-mapping-test-suite.cc	2023-03-16 20:54:23.832869300 -0700
@@ -227,9 +227,12 @@
     // Get the four child queue discs and connect their Enqueue trace to the
     // PacketEnqueuedInQueueDisc method, which counts how many packets with the given ToS value have
     // been enqueued
+    // NOTE the purpose of the unary + operation in +m_QueueDiscCount is to decay the array type
+    // to a pointer type, so that the type of that argument matches the type of the second
+    // parameter of the PacketEnqueuedInQueueDisc function
     root->GetQueueDiscClass(0)->GetQueueDisc()->TraceConnectWithoutContext(
         "Enqueue",
-        MakeBoundCallback(&WifiAcMappingTest::PacketEnqueuedInQueueDisc, m_tos, m_QueueDiscCount));
+        MakeBoundCallback(&WifiAcMappingTest::PacketEnqueuedInQueueDisc, m_tos, +m_QueueDiscCount));
 
     root->GetQueueDiscClass(1)->GetQueueDisc()->TraceConnectWithoutContext(
         "Enqueue",
@@ -254,12 +257,15 @@
     // Get the four wifi mac queues and connect their Enqueue trace to the
     // PacketEnqueuedInWifiMacQueue method, which counts how many packets with the given ToS value
     // have been enqueued
+    // NOTE the purpose of the unary + operation in +m_WifiMacQueueCount is to decay the array type
+    // to a pointer type, so that the type of that argument matches the type of the second
+    // parameter of the PacketEnqueuedInWifiMacQueue function
     apMac->GetAttribute("BE_Txop", ptr);
     ptr.Get<QosTxop>()->GetWifiMacQueue()->TraceConnectWithoutContext(
         "Enqueue",
         MakeBoundCallback(&WifiAcMappingTest::PacketEnqueuedInWifiMacQueue,
                           m_tos,
-                          m_WifiMacQueueCount));
+                          +m_WifiMacQueueCount));
 
     apMac->GetAttribute("BK_Txop", ptr);
     ptr.Get<QosTxop>()->GetWifiMacQueue()->TraceConnectWithoutContext(
